#include "UKListBox.h"

HINSTANCE g_hInstance;

void PridatSoubor(HWND hWnd)
{
	TCHAR szSoubor[MAX_PATH];
	lstrcpy(szSoubor, _T(""));
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFile = szSoubor;
	ofn.nMaxFile = sizeof(szSoubor);
	ofn.lpstrFilter = TEXT("Vechny soubory\0*.*\0");
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if ( !GetOpenFileName(&ofn) ) 
		return;
	SendDlgItemMessage(hWnd, IDC_LISTBOX, LB_ADDSTRING, 0,
		(LPARAM)szSoubor);
}

void DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
	TCHAR szSoubor[MAX_PATH];
	HBRUSH hbPozadi;
	SendMessage(lpDIS->hwndItem, LB_GETTEXT, lpDIS->itemID, (LPARAM)szSoubor);
		WORD index = 0;
	HICON hIcon = ExtractAssociatedIcon(g_hInstance, szSoubor, &index);
	if ( lpDIS->itemState & ODS_SELECTED )
	{
		hbPozadi = GetSysColorBrush(COLOR_HIGHLIGHT);
		SetTextColor(lpDIS->hDC, GetSysColor(COLOR_HIGHLIGHTTEXT));
	}
	else
	{
		hbPozadi = GetSysColorBrush(COLOR_WINDOW);
		SetTextColor(lpDIS->hDC, GetSysColor(COLOR_WINDOWTEXT));
	}
	
	SetBkMode(lpDIS->hDC, TRANSPARENT);
	FillRect(lpDIS->hDC, &lpDIS->rcItem, hbPozadi);
	
	DrawIcon(lpDIS->hDC, lpDIS->rcItem.left + 1,
		lpDIS->rcItem.top +2, hIcon);
	RECT rect;
	CopyMemory(&rect, &lpDIS->rcItem, sizeof(RECT));
	rect.left += 34;
	DrawText(lpDIS->hDC, szSoubor, -1, &rect,
		DT_WORDBREAK | DT_VCENTER);
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPMEASUREITEMSTRUCT lpMIS;
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_PRIDAT:
					PridatSoubor(hWnd);
					break;
			}
			break;
		case WM_INITDIALOG:
			break;
		case WM_DRAWITEM:
			DrawItem((LPDRAWITEMSTRUCT)lParam);
			break;
		case WM_MEASUREITEM:
			lpMIS = (LPMEASUREITEMSTRUCT)lParam;
			lpMIS->itemHeight = GetSystemMetrics(SM_CYICON) + 4;
			break;
	}
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	g_hInstance = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
